if(!$addedTetrisMap){
 $remapDivision[$remapCount] = "Tetris";
 $remapName[$remapCount] = "Open Tetris GUI";
 $remapCmd[$remapCount] = "tetris_opengui";
 $remapCount++;
 $addedTetrisMap=1;
}

$Tetris::Piece0_0_0=-2;$Tetris::Piece0_0_1=0;
$Tetris::Piece0_1_0=-1;$Tetris::Piece0_1_1=0;
$Tetris::Piece0_2_0=0;$Tetris::Piece0_2_1=0;
$Tetris::Piece0_3_0=1;$Tetris::Piece0_3_1=0;
$Tetris::Piece0_Color="20 200 200 255";
$Tetris::Piece1_0_0=-1;$Tetris::Piece1_0_1=0;
$Tetris::Piece1_1_0=-1;$Tetris::Piece1_1_1=1;
$Tetris::Piece1_2_0=0;$Tetris::Piece1_2_1=1;
$Tetris::Piece1_3_0=1;$Tetris::Piece1_3_1=1;
$Tetris::Piece1_Color="20 20 200 255";
$Tetris::Piece2_0_0=1;$Tetris::Piece2_0_1=0;
$Tetris::Piece2_1_0=-1;$Tetris::Piece2_1_1=1;
$Tetris::Piece2_2_0=0;$Tetris::Piece2_2_1=1;
$Tetris::Piece2_3_0=1;$Tetris::Piece2_3_1=1;
$Tetris::Piece2_Color="200 110 20 255";
$Tetris::Piece3_0_0=-1;$Tetris::Piece3_0_1=0;
$Tetris::Piece3_1_0=-1;$Tetris::Piece3_1_1=1;
$Tetris::Piece3_2_0=0;$Tetris::Piece3_2_1=0;
$Tetris::Piece3_3_0=0;$Tetris::Piece3_3_1=1;
$Tetris::Piece3_Color="200 200 20 255";
$Tetris::Piece4_0_0=0;$Tetris::Piece4_0_1=0;
$Tetris::Piece4_1_0=1;$Tetris::Piece4_1_1=0;
$Tetris::Piece4_2_0=-1;$Tetris::Piece4_2_1=1;
$Tetris::Piece4_3_0=0;$Tetris::Piece4_3_1=1;
$Tetris::Piece4_Color="20 200 20 255";
$Tetris::Piece5_0_0=-1;$Tetris::Piece5_0_1=0;
$Tetris::Piece5_1_0=0;$Tetris::Piece5_1_1=0;
$Tetris::Piece5_2_0=1;$Tetris::Piece5_2_1=0;
$Tetris::Piece5_3_0=0;$Tetris::Piece5_3_1=1;
$Tetris::Piece5_Color="150 20 200 255";
$Tetris::Piece6_0_0=-1;$Tetris::Piece6_0_1=0;
$Tetris::Piece6_1_0=0;$Tetris::Piece6_1_1=0;
$Tetris::Piece6_2_0=0;$Tetris::Piece6_2_1=1;
$Tetris::Piece6_3_0=1;$Tetris::Piece6_3_1=1;
$Tetris::Piece6_Color="200 20 20 255";

$Tetris::Rot0_0=1;$Tetris::Rot0_1=1;
$Tetris::Rot1_0=1;$Tetris::Rot1_1=-1;
$Tetris::Rot2_0=-1;$Tetris::Rot2_1=-1;
$Tetris::Rot3_0=-1;$Tetris::Rot3_1=1;

$Tetris::ClearSound0="base/data/sound/notes/synth 4/synth4_04.wav";
$Tetris::ClearSound1="base/data/sound/notes/synth 4/synth4_06.wav";
$Tetris::ClearSound2="base/data/sound/notes/synth 4/synth4_08.wav";
$Tetris::ClearSound3="base/data/sound/notes/synth 4/synth4_11.wav";

function tetris_opengui(%var){
 if(!%var)
  return;
 if(tetrisgui.isawake())
  canvas.popdialog(tetrisgui);
 else
  canvas.pushdialog(tetrisgui);
}

function tetrisgui::onwake(%this,%obj){
 if(!%this.hasawoken){
  tetrisgui.hasawoken=1;
  %f=new fileobject();
  %f.openforread("config/client/Tetris High Score.txt");
  $Tetris::HighScore=%f.readline();
  %f.close();
  %f.delete();
  if(!$Tetris::HighScore)
   $Tetris::HighScore=0;
  tetris_settext("High: "@$Tetris::HighScore);
 }
 if($Tetris::Paused){
  $Tetris::Paused=0;
  $Tetris::Playing=1;
  $Tetris::TickSched=schedule(1000,0,tetris_tick);
 }
}

function tetris_newgame(){
 if($Tetris::Playing)
  return;
 $Tetris::Playing=1;
 for(%y=0;%y<20;%y++){
  for(%x=0;%x<10;%x++){
   $Tetris::Grid[%x,%y].color="20 20 20 255";
   $Tetris::Bin[%x,%y]=0;
  }
 }
 $Tetris::Tick=1050;
 $Tetris::NextPiece=getrandom(0,6);
 $Tetris::Level=1;
 $Tetris::NextLevel=500;
 $Tetris::Score=0;
 TetrisLevel.settext("Level: 1");
 TetrisScore.settext("Score: 0");
 tetris_settext("Game Start",5000);
 TetrisButton.settext("End Game");
 TetrisButton.command="tetris_endgame();";
 for(%y=0;%y<$Tetris::StartingHeight;%y++){
  for(%x=0;%x<10;%x++){
   if(getrandom(0,1)){
    $Tetris::Grid[%x,20-%y].color=$Tetris::Piece[getrandom(0,6),"Color"];
    $Tetris::Bin[%x,20-%y]=1;
   }
  }
 }
 $Tetris::PieceListCount=0;
 tetris_newpiece();
// tetris_playsound("base/data/sound/admin.wav");
}

function tetris_settext(%s,%t){
 cancel($Tetris::TextSched);
 TetrisText.settext(%s);
 if(%s!$="" && %t)
  $Tetris::TextSched=schedule(%t,0,tetris_settext,"");
}

function tetris_newpiece(){
 %fail=0;
 %p=$Tetris::NextPiece;
 if(!$Tetris::PieceListCount){
  for(%x=0;%x<7;%x++){
   $Tetris::PieceList[%x*3]=%x;
   $Tetris::PieceList[%x*3+1]=%x;
   $Tetris::PieceList[%x*3+2]=%x;
  }
  $Tetris::PieceListCount=21;
 }
 %n=getrandom(0,$Tetris::PieceListCount--);
 $Tetris::NextPiece=$Tetris::PieceList[%n];
 $Tetris::PieceList[%n]=$Tetris::PieceList[$Tetris::PieceListCount];
 for(%y=0;%y<2;%y++){
  for(%x=0;%x<4;%x++)
   $Tetris::PreviewGrid[%x,%y].color="20 20 20 255";
 }
 for(%x=0;%x<4;%x++)
  $Tetris::PreviewGrid[$Tetris::Piece[$Tetris::NextPiece,%x,0]+2,$Tetris::Piece[$Tetris::NextPiece,%x,1]].color=$Tetris::Piece[$Tetris::NextPiece,"Color"];
 $Tetris::Curr=%p;
 $Tetris::Offset0=5;
 $Tetris::Offset1=0;
 $Tetris::Rot=0;
 for(%x=0;%x<4;%x++){
  $Tetris::Curr[%x,0]=$Tetris::Piece[%p,%x,0]+5;
  $Tetris::Curr[%x,1]=$Tetris::Piece[%p,%x,1];
  $Tetris::Last[%x,0]=$Tetris::Curr[%x,0];
  $Tetris::Last[%x,1]=$Tetris::Curr[%x,1];
 }
 for(%x=0;%x<4;%x++){
  if($Tetris::Bin[$Tetris::Curr[%x,0],$Tetris::Curr[%x,1]]){
   %fail=1;
   break;
  }
 }
 $Tetris::CurrPiece=%p;
 $Tetris::CurrColor=$Tetris::Piece[%p,"color"];
 tetris_display();
 if(%fail){
  //game over
  tetris_endgame();
 }else
  $Tetris::TickSched=schedule($Tetris::Tick,0,tetris_tick);
}

function tetris_display(){
 for(%x=0;%x<4;%x++)
  $Tetris::Grid[$Tetris::Last[%x,0],$Tetris::Last[%x,1]].color="20 20 20 255";
 for(%x=0;%x<4;%x++)
  $Tetris::Grid[$Tetris::Curr[%x,0],$Tetris::Curr[%x,1]].color=$Tetris::CurrColor;
}

function tetris_shift(%v,%invisible){
 if($Tetris::CurrPiece==-1)
  return;
 if(%v==1)
  %check=10;
 else
  %check=-1;
 for(%x=0;%x<4;%x++){
  $Tetris::Last[%x,0]=$Tetris::Curr[%x,0];
  $Tetris::Last[%x,1]=$Tetris::Curr[%x,1];
  $Tetris::Curr[%x,0]+=%v;
 }
 for(%x=0;%x<4;%x++){
  if($Tetris::Curr[%x,0]==%check || $Tetris::Bin[$Tetris::Curr[%x,0],$Tetris::Curr[%x,1]]){
   %fail=1;
   break;
  }
 }
 if(%fail){
  for(%x=0;%x<4;%x++){
   $Tetris::Curr[%x,0]=$Tetris::Last[%x,0];
   $Tetris::Curr[%x,1]=$Tetris::Last[%x,1];
  }
  return(0);
 }else{
  $Tetris::Offset0+=%v;
  if(!%invisible)
   tetris_display();
  tetris_playsound("base/data/sound/clickmove.wav");
  return(1);
 }
}

function tetris_rotate(%v){
 if($Tetris::CurrPiece==-1 ||$Tetris::CurrPiece==3)
  return;
 %rot=$Tetris::Rot+%v;
 if(%rot<0)
  %rot=3;
 else if(%rot>3)
  %rot=0;
 %min=0;
 for(%x=0;%x<4;%x++){
  $Tetris::Last[%x,0]=$Tetris::Curr[%x,0];
  $Tetris::Last[%x,1]=$Tetris::Curr[%x,1];
  %temp=$Tetris::Curr[%x,0];
  $Tetris::Curr[%x,0]=($Tetris::Curr[%x,1]-$Tetris::Offset1)*%v+$Tetris::Offset0;
  $Tetris::Curr[%x,1]=(%temp-$Tetris::Offset0)*-1*%v+$Tetris::Offset1;
 }
 for(%x=0;%x<4;%x++){
  if($Tetris::Curr[%x,0]<0 || $Tetris::Curr[%x,0]>9 || $Tetris::Curr[%x,1]>19 || $Tetris::Bin[$Tetris::Curr[%x,0],$Tetris::Curr[%x,1]]){
   %fail=1;
   break;
  }else if($Tetris::Curr[%x,1]<0){
   if($Tetris::Curr[%x,1]<%min)
    %min=$Tetris::Curr[%x,1];
  }
 }
 if(%min<0){
  $Tetris::Offset1-=%min;
  for(%x=0;%x<4;%x++){
   $Tetris::Curr[%x,1]-=%min;
   if($Tetris::Bin[$Tetris::Curr[%x,0],$Tetris::Curr[%x,1]]){
    %fail=1;
    break;
   }
  }
 }
 if(%fail){
  for(%x=0;%x<4;%x++){
   $Tetris::Curr[%x,0]=$Tetris::Last[%x,0];
   $Tetris::Curr[%x,1]=$Tetris::Last[%x,1];
  }
 }else{
  $Tetris::Rot=%rot;
  tetris_display();
  tetris_playsound("base/data/sound/clickrotate.wav");
 }
}

function tetris_advance(){
 if($Tetris::CurrPiece==-1)
  return;
 cancel($Tetris::TickSched);
 %c=0;
 while(tetris_tick(1)){
  %c++;
  cancel($Tetris::TickSched);
 }
 for(%x=0;%x<4;%x++){
  $Tetris::Curr[%x,0]=$Tetris::Last[%x,0];
  $Tetris::Curr[%x,1]=$Tetris::Last[%x,1];
 }
 tetris_display();
 if(%c){
  $Tetris::TickSched=schedule($Tetris::Tick,0,tetris_tick);
  $Tetris::Score+=%c;
  TetrisScore.settext("Score: "@$Tetris::Score);
  tetris_playsound("base/data/sound/clicksupermove.wav");
 }else
  tetris_tick();
}

function tetris_tick(%auto){
 if(!$Tetris::Playing)
  return;
 if(!TetrisGui.isawake()){
  $Tetris::Paused=1;
  $Tetris::Playing=0;
  return;
 }
 if(!$Tetris::NextLevel--)
  tetris_nextlevel();
 %fail=0;
 for(%x=0;%x<4;%x++){
  $Tetris::Last[%x,0]=$Tetris::Curr[%x,0];
  $Tetris::Last[%x,1]=$Tetris::Curr[%x,1];
  $Tetris::Curr[%x,1]++;
 }
 for(%x=0;%x<4;%x++){
  if($Tetris::Curr[%x,1]==20){
   %fail=1;
   break;
  }
  if($Tetris::Bin[$Tetris::Curr[%x,0],$Tetris::Curr[%x,1]]){
   %fail=1;
   break;
  }
 }
 if(%fail){
  if(%auto)
   return(0);
  for(%x=0;%x<4;%x++){
   $Tetris::Curr[%x,0]=$Tetris::Last[%x,0];
   $Tetris::Curr[%x,1]=$Tetris::Last[%x,1];
   $Tetris::Bin[$Tetris::Last[%x,0],$Tetris::Last[%x,1]]=1;
  }
  for(%x=0;%x<4;%x++){
   if(!%checked[$Tetris::Curr[%x,1]]){
    %checked[$Tetris::Curr[%x,1]]=1;
    %c=0;
    for(%a=0;%a<10;%a++){
     if($Tetris::Bin[%a,$Tetris::Curr[%x,1]])
      %c++;
    }
    if(%c==10)
     %clear=setword(%clear,getwordcount(%clear),$Tetris::Curr[%x,1]);
   }
  }
  $Tetris::Score+=10;
  TetrisScore.settext("Score: "@$Tetris::Score);
  $Tetris::CurrPiece=-1;
  if(getwordcount(%clear)){
   tetris_clear(%clear);
  }else{
   tetris_newpiece();
   tetris_playsound("base/data/sound/clickplant.wav");
  }
  return(0);
 }else{
  $Tetris::Offset1++;
  tetris_display();
  $Tetris::TickSched=schedule($Tetris::Tick,0,tetris_tick);
  return(1);
 }
}

function tetris_nextlevel(){
 if($Tetris::Level!=20){
  $Tetris::NextLevel=500;
  $Tetris::Level++;
  TetrisLevel.settext("Level: "@$Tetris::Level);
  $Tetris::Tick-=50;
  if($Tetris::Level==20)
   tetris_settext("\c5Final Level!",5000);
  else
   tetris_settext("\c5Level Up!",5000);
//  tetris_playsound("base/data/sound/admin.wav");
 }
}

function tetris_clear(%clear){
 %clearcount=getwordcount(%clear);
 for(%c=0;%c<%clearcount;%c++){
  %y=getword(%clear,%c);
  for(%x=0;%x<10;%x++)
   $Tetris::Grid[%x,%y].color="200 200 200 255";
 }
 if(%clearcount==4)
  tetris_settext("\c4Tetris!",5000);
 for(%x=0;%x<%clearcount;%x++)
  schedule(140*%x,0,tetris_playsound,$Tetris::ClearSound[%x]);
 $Tetris::TickSched=schedule($Tetris::Tick,0,tetris_clear2,%clear);
}

function tetris_clear2(%clear){
 %clearcount=getwordcount(%clear);
 for(%c=0;%c<%clearcount;%c++){
  %y=getword(%clear,%c);
  for(%b=%y;%b>0;%b--){
   for(%a=0;%a<10;%a++){
    $Tetris::Grid[%a,%b].color=$Tetris::Grid[%a,%b-1].color;
    $Tetris::Bin[%a,%b]=$Tetris::Bin[%a,%b-1];
   }
  }
  for(%x=%clearcount-1;%x>%c;%x--){
   if(getword(%clear,%x)<%y)
    %clear=setword(%clear,%x,getword(%clear,%x)+1);
  }
  for(%x=0;%x<10;%x++){
   $Tetris::Grid[%x,0].color="20 20 20 255";
   $Tetris::Bin[%x,0]=0;
  }
 }
 $Tetris::Score+=(%clearcount*%clearcount+%clearcount)*(450+50*$Tetris::Level);
 TetrisScore.settext("Score: "@$Tetris::Score);
 tetris_newpiece();
}

function tetris_endgame(){
 if(!$Tetris::Playing)
  return;
 $Tetris::Playing=0;
 cancel($Tetris::TickSched);
 cancel($Tetris::ShiftSched);
 TetrisButton.settext("New Game");
 TetrisButton.command="tetris_newgame();";
 tetris_settext("Game Over");
 if($Tetris::Score>999999){
  $tetris::score=$tetris::score/10@getrandom(0,9);
  tetrisscore.settext("Score: "@$tetris::score);
  tetriswindow.settext("Tetris  1,000,000 Points!");
  tetris_playsound("add-ons/music/after school special.ogg");
  tetris_winani(0,0,-1,0);
 }
 if($Tetris::Score>$Tetris::HighScore){
  schedule(1000,0,tetris_settext,"High Score!");
  %f=new fileobject();
  %f.openforwrite("config/client/Tetris High Score.txt");
  %f.writeline($Tetris::Score);
  %f.close();
  %f.delete();
  $Tetris::HighScore=$Tetris::Score;
 }else{
  schedule(3000,0,tetris_settext,"High: "@$Tetris::HighScore);
 }
 tetris_playsound("base/data/sound/death.wav");
}

function tetris_playsound(%file){
 %h=alxcreatesource(AudioChannel0,%file);
 alxplay(%h);
}

function tetris_winani(%fr,%x,%v,%col){
 if($Tetris::Playing)
  return;
 $Tetris::Grid[getrandom(0,9),getrandom(0,12)].color=$Tetris::Piece[getrandom(0,6),"Color"];
 if(%v==1)
  %a=%x-1;
 else
  %a=%x+5;
 for(%b=13;%b<20;%b++)
  $Tetris::Grid[%a,%b].color="20 20 20 255";
 switch(%fr){
  case(1): %bin="00100011100010011111001000101001010";
  case(2): %bin="00100011101010101110001000101010001";
  default: %bin="00100011100010001110101010101001010";
 }
 %c=0;
 %color=(0.5+0.5*mSin(%col*$piOver16)) SPC (0.5+0.5*mSin(%col*$piOver16+21)) SPC (0.5+0.5*mSin(%col*$piOver16+42)) SPC "255";
 %col++;
 for(%b=13;%b<20;%b++){
  for(%a=0;%a<5;%a++){
   if(getsubstr(%bin,-1+%c++,1)$="1")
    $Tetris::Grid[%a+%x,%b].setcolor(%color);
   else
    $Tetris::Grid[%a+%x,%b].color="20 20 20 255";
  }
 }
 %fr++;
 if(%fr==3)
  %fr=0;
 if(%x==0)
  %v=1;
 else if(%x==5)
  %v=-1;
 %x+=%v;
 schedule(100,0,tetris_winani,%fr,%x,%v,%col);
}

$piOver16=3.14159/16;

if(!isobject(tetrisgui))
 exec("./tetrisgui.gui");

function tetris_toggleimg(){
 $Tetris::Image++;
 if($Tetris::Image==4)
  $Tetris::Image=0;
 switch($Tetris::Image){
  case(1): %img="base/data/shapes/brickbottomloop";
  case(2): %img="base/client/ui/btndecal_i";
  case(3): %img="base/data/printicons/2x2/vent";
  default: %img="base/data/shapes/bricktop";
 }
 for(%y=0;%y<20;%y++){
  for(%x=0;%x<10;%x++){
   $tetris::overlay[%x,%y].setbitmap(%img);
  }
 }
}

package tetris{
 function shiftbrickleft(%var,%hold){
  if($Tetris::Playing){
   cancel($Tetris::ShiftSched);
   if(%var){
    tetris_shift(-1);
    $Tetris::HoldShift=-1;
    if(%hold)
     $Tetris::ShiftSched=schedule(30,0,shiftbrickleft,1,1);
    else
     $Tetris::ShiftSched=schedule(200,0,shiftbrickleft,1,1);
   }else
    $Tetris::HoldShift=0;
  }else
   parent::shiftbrickleft(%var);
 }
 function shiftbrickright(%var,%hold){
  if($Tetris::Playing){
   cancel($Tetris::ShiftSched);
   if(%var){
    tetris_shift(1);
    $Tetris::HoldShift=1;
    if(%hold)
     $Tetris::ShiftSched=schedule(30,0,shiftbrickright,1,1);
    else
     $Tetris::ShiftSched=schedule(200,0,shiftbrickright,1,1);
   }else
    $Tetris::HoldShift=0;
  }else
   parent::shiftbrickright(%var);
 }
 function shiftbrickaway(%var,%hold){
  if($Tetris::Playing){
   cancel($Tetris::RotSched);
   if(%var){
    tetris_rotate(1);
    if(%hold)
     $Tetris::RotSched=schedule(100,0,shiftbrickaway,1,1);
    else
     $Tetris::RotSched=schedule(400,0,shiftbrickaway,1,1);
   }
  }else
   parent::shiftbrickaway(%var);
 }
 function shiftbrickdown(%var,%hold){
  if($Tetris::Playing){
   cancel($Tetris::AdvSched);
   if(%var){
    tetris_advance(1);
    if(%hold)
     $Tetris::AdvSched=schedule(30,0,shiftbrickdown,1,1);
    else
     $Tetris::AdvSched=schedule(500,0,shiftbrickdown,1,1);
   }
  }else
   parent::shiftbrickdown(%var);
 }
 function shiftbricktowards(%var,%hold){
  if($Tetris::Playing){
   cancel($Tetris::RotSched);
   if(%var){
    tetris_rotate(-1);
    if(%hold)
     $Tetris::RotSched=schedule(100,0,shiftbricktowards,1,1);
    else
     $Tetris::RotSched=schedule(400,0,shiftbricktowards,1,1);
   }
  }else
   parent::shiftbricktowards(%var);
 }
};
activatepackage(tetris);